package space.kklochko.jdbc_hospital_example.cli.commands.factories;

import lombok.NonNull;
import space.kklochko.jdbc_hospital_example.cli.commands.CommandData;
import space.kklochko.jdbc_hospital_example.cli.commands.CommandEntities;
import space.kklochko.jdbc_hospital_example.db.repositories.AbstractRepository;

import java.lang.reflect.Method;

public class ReadAllFactory {
    public <T> CommandEntities<T> create(@NonNull CommandData commandData, @NonNull AbstractRepository<T> repository) {
        try {
            Method method = repository.getClass().getMethod("readAll");
            return new CommandEntities<T>(repository, method);
        } catch (NoSuchMethodException e) {
            throw new RuntimeException(e);
        }
    }
}
